using System.Collections.Generic;
using System;
using System.Globalization;
using System.Text;
using Newtonsoft.Json.Linq;
using System.Linq;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;

namespace AyaNova.DataList
{
    internal class SqlSelectBuilderResult
    {
        internal Dictionary<string, int> map { get; set; }
        internal string Select { get; set; }
    }
    internal static class DataListSqlSelectBuilder
    {

        //Build the SELECT portion of a list query based on the ListView fields 
        internal static SqlSelectBuilderResult Build(List<AyaDataListFieldDefinition> objectFieldsList, List<string> listViewFieldList)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("SELECT ");

            //keep track of which custom fields columns were added already
            //this ensures that if there is more than one set of custom fields like from two different objects in the list
            //only unique ones will be returned by query           
            //map sql column name to ordinal name
            Dictionary<string, int> map = new Dictionary<string, int>();
            int nOrdinal = 0;

            var firstColumnAdded = false;
            foreach (string ColumnName in listViewFieldList)
            {
                AyaDataListFieldDefinition o = objectFieldsList.FirstOrDefault(z => z.FieldKey == ColumnName);
#if (DEBUG)
                //Developers little helper
                if (o == null)
                {
                    throw new System.ArgumentNullException($"DEV ERROR in DataListSqlSelectBuilder.cs:Build() field {ColumnName} specified in template was NOT found in ObjectFields list");
                }
#endif
                if (o != null)
                {//Ignore missing fields in production
                    if (o.IsCustomField)
                    { //if any are custom field then add custom fields column to query
                        var CustomFieldSqlColumnName = o.GetSqlValueColumnName();
                        //has it been added yet?
                        if (!map.ContainsKey(CustomFieldSqlColumnName))
                        { //nope
                            if (firstColumnAdded)
                                sb.Append(", ");
                            sb.Append(CustomFieldSqlColumnName);
                            firstColumnAdded = true;
                            map.Add(CustomFieldSqlColumnName, nOrdinal++);
                        }
                    }
                    else
                    {
                        var valueColumnName = o.GetSqlValueColumnName();
                        if (!map.ContainsKey(valueColumnName))
                        {
                            if (firstColumnAdded)
                                sb.Append(", ");
                            sb.Append(valueColumnName);
                            firstColumnAdded = true;
                            map.Add(valueColumnName, nOrdinal++);
                        }

                        //does it also have an ID column?
                        var idColumnName = o.SqlIdColumnName;
                        if (!string.IsNullOrWhiteSpace(idColumnName))
                        {
                            if (!map.ContainsKey(idColumnName))
                            {
                                if (firstColumnAdded)
                                    sb.Append(", ");
                                sb.Append(idColumnName);
                                firstColumnAdded = true;
                                map.Add(idColumnName, nOrdinal++);
                            }
                        }
                    }
                }
            }
            return new SqlSelectBuilderResult() { map = map, Select = sb.ToString() };
        }//eof



        //Build the SELECT portion of a list query but only to return rowid's
        internal static SqlSelectBuilderResult BuildForReportIdListOnly(List<AyaDataListFieldDefinition> objectFieldsList, List<string> listViewFieldList)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("SELECT ");
            //map sql column name to ordinal name
            Dictionary<string, int> map = new Dictionary<string, int>();
            int nOrdinal = 0;

            var firstColumnAdded = false;
            foreach (string ColumnName in listViewFieldList)
            {
                AyaDataListFieldDefinition o = objectFieldsList.FirstOrDefault(z => z.FieldKey == ColumnName);
#if (DEBUG)
                //Developers little helper
                if (o == null)
                {
                    throw new System.ArgumentNullException($"DEV ERROR in DataListSqlSelectBuilder.cs:BuildForReportIdListOnly() field {ColumnName} specified in template was NOT found in ObjectFields list");
                }
#endif
                if (o != null && o.IsRowId)//only return the rowid column
                {//Ignore missing fields in production

                    var valueColumnName = o.GetSqlValueColumnName();
                    if (!map.ContainsKey(valueColumnName))
                    {
                        if (firstColumnAdded)
                            sb.Append(", ");
                        sb.Append(valueColumnName);
                        firstColumnAdded = true;
                        map.Add(valueColumnName, nOrdinal++);
                    }

                    //does it also have an ID column?
                    var idColumnName = o.SqlIdColumnName;
                    if (!string.IsNullOrWhiteSpace(idColumnName))
                    {
                        if (!map.ContainsKey(idColumnName))
                        {
                            if (firstColumnAdded)
                                sb.Append(", ");
                            sb.Append(idColumnName);
                            firstColumnAdded = true;
                            map.Add(idColumnName, nOrdinal++);
                        }
                    }
                }
            }
            return new SqlSelectBuilderResult() { map = map, Select = sb.ToString() };
        }//eof


    }//eoc
}//ens
